class Bullet { // width:4 height: 16
  float moveX;
  float moveY;
  boolean displayBu = true;
  boolean moveBu= true;
  int hideBu; // timer 

  Bullet() {
    moveX = pl.moveX+12;
    moveY = pl.moveY;
  }

  void display() {
    // time needed before shooting again, while shoot-button is pressed & hold.
    if (bulletTimer>=10) { 
      bulletTimer = 0;
    }
    if (displayBu) {
      fill(#ffc545);// yellow
      noStroke(); 
      pushMatrix();
      translate(moveX, moveY);
      rect(0, 0, 4, 16);
      popMatrix();
    }
    move();
  }

  // the bullets moves form its location of release to the top of screen
  void move() { 
    if (bulletAlive == true) {
      float movementBullet = lerp(10, 0, .1);
      moveY = moveY - movementBullet;
    }
  }

  // when shoud the bullets stop
  boolean bulletDead() {
    if (moveY <= 0) {
      return true; // true == bullet should disapear
    } else {
      // shooting ship
      for (int i=0; i < sh.length; i++) {
        if ( 
          ( (sh[i].direction == 1) && ((this.moveX+4 >= sh[i].moveX && this.moveX <= sh[i].moveX+64) && (this.moveY <= sh[i].moveY+ frame +16 && this.moveY+16 > sh[i].moveY+ frame) && sh[i].displaySh) ) ||
          ( (sh[i].direction == -1) && ((this.moveX+4 >= sh[i].moveX-64 && this.moveX <= sh[i].moveX) && (this.moveY <= sh[i].moveY+frame+16 && this.moveY+16 > sh[i].moveY+frame) && sh[i].displaySh) )
          ) {
          file[2].play();
          sh[i].explosionTime = 0;
          sh[i].explodeSh = true;        
          totScore++;
          return true;
        }
      }
      // shooting chopper 
      for (int i=0; i < ch.length; i++) {
        if ( 
          ( (ch[i].direction == 1) && ((this.moveX+4 >= ch[i].moveX && this.moveX <= ch[i].moveX+32) && (this.moveY <= ch[i].moveY+ frame +20 && this.moveY+16 > ch[i].moveY+ frame) &&ch[i].displayCh) ) ||
          ( (ch[i].direction == -1) && ((this.moveX+4 >= ch[i].moveX-32 && this.moveX <= ch[i].moveX) && (this.moveY <= ch[i].moveY+frame+20 && this.moveY+16 >ch[i].moveY+frame) && ch[i].displayCh) )
          ) {
          file[3].play();
          ch[i].explosionTime = 0;
          ch[i].explodeCh = true;        
          totScore++;
          return true;
        }
      }    
      return false;
    }
  }
} // end Bullet
